//
//  Report.m
//  iCloud Reports
//
//  Created by Jesse Feiler on 2/4/13.
//  Copyright (c) 2013 Champlain Arts. All rights reserved.
//

#import "ReportDocument.h"

@interface ReportDocument ()

@end

@implementation ReportDocument

- (void)setDocumentText: (NSString *)newText {                                  //1
  
  NSString *oldText = _documentText;
	_documentText = [newText copy];
	
	// prepare for undo
	[self.undoManager registerUndoWithTarget: self selector:@selector (setdocumentText:) object:oldText];  //2

}

- (id)contentsForType: (NSString *)typeName error: (NSError **)outError {       //3
	if (!self.documentText)
		self.documentText = @"";
	NSData *docData = [self.documentText dataUsingEncoding: NSUTF8StringEncoding]; //4
	return docData;
}

- (BOOL)loadFromContents:(id)contents ofType:(NSString *)typeName
    error:(NSError *__autoreleasing *)outError {                                        //5
  if ([contents length] > 0)
		self.documentText = [[NSString alloc] initWithData: contents encoding: NSUTF8StringEncoding];
	else
		self.documentText = @"";
	
	if (self.delegate && [self.delegate respondsToSelector: @selector(documentContentsDidChange:)])
		[self.delegate documentContentsDidChange: self];                                     //6
	
	return YES;
}

@end
