//
//  JFSimpleTextDocument.m
//  Placid
//
//  Created by Jesse Feiler on 7/3/13.
//  Copyright (c) 2013 Champlain Arts. All rights reserved.
//

#import "JFSimpleTextDocument.h"

@implementation JFSimpleTextDocument

- (void)setDocumentText:(NSString *)newText {
  
  NSString* oldText = _documentText;
  _documentText = [newText copy];

  //Register undo
  [self.undoManager setActionName: @"Text Change"];
  [self.undoManager registerUndoWithTarget:self selector:@selector(setDocumentText:) object:oldText];
}

- (id)contentsForType:(NSString *)typeName error:(NSError *__autoreleasing *)outError {
  if (!self.documentText)
    self.documentText = @"";
  
  NSData *docData = [self.documentText dataUsingEncoding:NSUTF8StringEncoding];
  
  return docData;
}

- (BOOL)loadFromContents:(id)contents ofType:(NSString *)typeName error:(NSError *__autoreleasing *)outError {
  if ([contents length] > 0)
    self.documentText = [[NSString alloc]
                         initWithData:contents encoding:NSUTF8StringEncoding];
  else
    self.documentText = @"";
  
  // tell the delegate
  
  if (self.delegate && [self.delegate respondsToSelector: @selector (documentContentsDidChange:)])
    [self.delegate documentContentsDidChange: self];
  
  return YES;
}

@end
