
//
//  JFWindowController.m
//  Chazy
//
//  Created by Champlain Arts Corp on 8/4/13.
//  Copyright (c) 2013 Champlain Arts Corp. All rights reserved.
//

#import "JFWindowController.h"
#import "JFWrappedDocument.h"

@interface JFWindowController ()

@property (weak, nonatomic, readwrite) IBOutlet NSTextField *textField;
@property (weak, nonatomic, readwrite) IBOutlet NSTextField *locationField;
@property (weak, nonatomic, readwrite) IBOutlet NSImageView *imageView;

@end

@implementation JFWindowController

//debug

- (void)setDocument: (NSDocument *)document {
  [super setDocument:document];
}

- (id)init {
  
  self = [super initWithWindowNibName:@"JFWrappedDocument"]; //*****
  if (self) {
    // Initialization code here.
  }
  return self;
}

/*
 - (id)initWithWindow:(NSWindow *)window
{
    self = [super initWithWindow:window];
    if (self) {
        // Initialization code here.
    }
    return self;
}*/

- (void)windowDidLoad
{
    [super windowDidLoad];
    
    // Implement this method to handle any initialization after your window controller's window has been loaded from its nib file.
  
    //NSLog( @" %s %@", __PRETTY_FUNCTION__, self);
}

#pragma mark - Notifications
- (void)controlTextDidEndEditing:(NSNotification *)aNotification
{
  NSTextField *textField = [aNotification object];
  if (_textField == textField) {
    ((JFWrappedDocument *)self.document).documentDescription = [textField stringValue];
  } else if (_locationField == textField) {
    ((JFWrappedDocument *)self.document).documentLocation = [textField stringValue];
  }
    
  NSLog (@" %s, %@ %@", __PRETTY_FUNCTION__,((JFWrappedDocument *)self.document).documentDescription, ((JFWrappedDocument *)self.document).documentLocation);
  // should check if changed
  [self UIContentsDidChange: self.document];
}

- (void)documentContentsDidChange: (JFWrappedDocument *)document {  //5
  [self.textField setStringValue: document.documentDescription];
  [self.locationField setStringValue: document.documentLocation];
}

- (void)UIContentsDidChange: (JFWrappedDocument *)document {  //5
  NSLog (@" %s %@ %@ %@", __PRETTY_FUNCTION__, @"before", [_textField stringValue],[_locationField stringValue]);
  document.documentDescription = [_textField stringValue];
  document.documentLocation = [_locationField stringValue];
  NSLog (@" %s %@ %@ %@", __PRETTY_FUNCTION__, @"after", document.documentDescription, document.documentLocation);
}


@end
