//
//  JFWrappedDocument.h
//  Chazy
//
//  Created by Champlain Arts Corp on 8/4/13.
//  Copyright (c) 2013 Champlain Arts Corp. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "JFWindowController.h"

@protocol JFDocumentDelegate;  //1

@interface JFWrappedDocument : NSDocument

@property (strong, nonatomic) NSFileWrapper *documentFileWrapper;

@property (strong, nonatomic) NSString *documentDescription;
@property (strong, nonatomic) NSString *documentLocation;
@property (weak) IBOutlet NSTextField *descriptionField;
@property (weak) IBOutlet NSTextField *locationField;

@property (weak, nonatomic) id <JFDocumentDelegate> delegate;  //2

@property (weak, nonatomic) JFWindowController *windowController;

-(void)setDocumentDescription: (NSString*)newText;
-(void)setDocumentLocation: (NSString*)newText;
@end

@protocol JFDocumentDelegate <NSObject>  //3
@optional
- (void)documentContentsDidChange: (JFWrappedDocument *)document;

@end
