
//
//  JFWindowController.m
//  Chazy
//
//  Created by Champlain Arts Corp on 8/4/13.
//  Copyright (c) 2013 Champlain Arts Corp. All rights reserved.
//

#import "JFWindowController.h"
#import "JFWrappedDocument.h"

@interface JFWindowController () //1

@end

@implementation JFWindowController

- (void)setDocument: (NSDocument *)document {  //2
  [super setDocument:document];
}

- (id)init {
  
  self = [super initWithWindowNibName:@"JFWrappedDocument"];  //3
  if (self) {
    // Initialization code here.
  }
  return self;
}

- (void)windowDidLoad   //4
{
    [super windowDidLoad];
    
    // Implement this method to handle any initialization after your window controller's window
    // has been loaded from its nib file.
}

#pragma mark - moving to/from UI
- (void)documentContentsDidChange: (JFWrappedDocument *)document {  //5
  NSLog (@" %s %@", __PRETTY_FUNCTION__, document);
  NSLog (@" %s %@ %@", __PRETTY_FUNCTION__, self.fieldDescription, document.documentDescription);
  NSLog (@" %s %@ %@", __PRETTY_FUNCTION__, self.fieldLocation, document.documentLocation);
  [self.fieldDescription setStringValue: document.documentDescription];
  [self.fieldLocation setStringValue: document.documentLocation];
}

- (void)UIContentsDidChange: (JFWrappedDocument *)document {  //6
  NSLog (@" %s %@ %@", __PRETTY_FUNCTION__, self.fieldDescription, document.documentDescription);
  NSLog (@" %s %@ %@", __PRETTY_FUNCTION__, self.fieldLocation, document.documentLocation);
  document.documentDescription = [_fieldDescription stringValue];
  document.documentLocation = [_fieldLocation stringValue];
}

#pragma mark - Notifications
- (void)controlTextDidEndEditing:(NSNotification *)aNotification  //7
{
  NSTextField *fieldDescription = [aNotification object];
  if (_fieldDescription == fieldDescription) {
    ((JFWrappedDocument *)self.document).documentDescription = [fieldDescription stringValue];
  } else if (_fieldDescription == fieldDescription) {
    ((JFWrappedDocument *)self.document).documentLocation = [fieldDescription stringValue];
  }
    
  // should check if changed
  [self UIContentsDidChange: self.document];
}

@end
