//
//  ViewController.m
//  PartII iOS
//
//  Created by Sams Publishing on 7/6/12.
//  Copyright (c) 2012 Champlain Arts. All rights reserved.
//

#import "ViewController.h"               //1
#import "Reachability.h"                 //2

#import <MessageUI/MessageUI.h>          //3
#import <MessageUI/MFMailComposeViewController.h> //4

@interface ViewController ()             //5

@end                                     //6

@implementation ViewController           //7
@synthesize userTextView;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
  if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
      return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
  } else {
      return YES;
  }
}

- (IBAction)tapButton:(id)sender {
  NSLog (@" %@", userTextView.text);
  
  Class mailClass = (NSClassFromString(@"MFMailComposeViewController"));
  if (mailClass != nil)                                 //2
  {
    // We must always check whether the current device is configured for sending emails
    if ([mailClass canSendMail])
    {
      NetworkStatus networkStatus = [[Reachability reachabilityForInternetConnection] currentReachabilityStatus];
      if (networkStatus == NotReachable) {
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle: @"Network Not Available"
                              message: @"You can continue to create minutes to send when you have a network connection."
                              delegate:nil
                              cancelButtonTitle:@"OK"
                              otherButtonTitles:nil];
        [alert show];                                   //3
      } else {
        [self displayComposerSheet];                    //4
      }
    }
    else
    {
      [self showCantSendMailAlert];                     //5
    }
  }
  else
  {
    [self showCantSendMailAlert];                       //6
  }
  
}

-(void)displayComposerSheet {
  MFMailComposeViewController *composer =
  [[MFMailComposeViewController alloc] init];           //1
  
  composer.mailComposeDelegate = self;
  
  [composer setSubject: @"Test Subject"];                 //7
  
  [composer setMessageBody: userTextView.text isHTML: NO];//8
  
  [self presentViewController: composer
    animated: YES completion:NULL];                       //9
}

-(void)showCantSendMailAlert                              //10
{
	
	UIAlertView *alert = [[UIAlertView alloc]
                        initWithTitle: @"Email Not Configured"
                        message: @"You can continue with the message but you will not be able to email it."
                        delegate:nil
                        cancelButtonTitle:@"OK"
                        otherButtonTitles:nil];
	[alert show];
}

#pragma mark MFMailComposeViewControllerDelegate

- (void)mailComposeController:(MFMailComposeViewController*)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error
{
  [self dismissViewControllerAnimated:YES completion:nil];
}

@end
