//
//  ViewController.m
//  PartII iOS
//
//  Created by Sams Publishing on 7/6/12.
//  Copyright (c) 2012 Champlain Arts. All rights reserved.
//

#import "ViewController.h"
#import "Reachability.h"

#import <MessageUI/MessageUI.h>
#import <MessageUI/MFMailComposeViewController.h>

@interface ViewController ()

@end

@implementation ViewController
//@synthesize userTextView;

- (void)viewDidLoad
{
  [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
  _eventStore = [[EKEventStore alloc] init];      //1
  
  [_eventStore requestAccessToEntityType: EKEntityTypeReminder completion:^(BOOL granted, NSError *error)  //2
  {
    if (!granted) {                                    //3
      UIAlertView *alert = [[UIAlertView alloc] initWithTitle: @"Error"
                                                      message: @"Can't access reminders"
                                                     delegate: nil
                                            cancelButtonTitle: @"OK"
                                            otherButtonTitles: nil];
      [alert show];
    }
  }];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
  if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
      return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
  } else {
      return YES;
  }
}

#pragma mark - Send Mail Button
- (IBAction)tapButton:(id)sender {
  NSLog (@" %@", _userTextView.text);
  
  Class mailClass = (NSClassFromString(@"MFMailComposeViewController"));
  if (mailClass != nil)                                 //2
  {
    // We must always check whether the current device is configured for sending emails
    if ([mailClass canSendMail])
    {
      NetworkStatus networkStatus = [[Reachability reachabilityForInternetConnection] currentReachabilityStatus];
      if (networkStatus == NotReachable) {
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle: @"Network Not Available"
                              message: @"You can continue to create minutes to send when you have a network connection."
                              delegate:nil
                              cancelButtonTitle:@"OK"
                              otherButtonTitles:nil];
        [alert show];                                   //3
      } else {
        [self displayComposerSheet];                    //4
      }
    }
    else
    {
      [self showCantSendMailAlert];                     //5
    }
  }
  else
  {
    [self showCantSendMailAlert];                       //6
  }
  
}

-(void)displayComposerSheet {
  MFMailComposeViewController *composer =
  [[MFMailComposeViewController alloc] init];           //1
  
  composer.mailComposeDelegate = self;
  
  [composer setSubject: @"Test Subject"];                 //7
  
  [composer setMessageBody: _userTextView.text isHTML: NO];//8
  
  [self presentViewController: composer
    animated: YES completion:NULL];                       //9
}

-(void)showCantSendMailAlert                              //10
{
	
	UIAlertView *alert = [[UIAlertView alloc]
                        initWithTitle: @"Email Not Configured"
                        message: @"You can continue with the message but you will not be able to email it."
                        delegate:nil
                        cancelButtonTitle:@"OK"
                        otherButtonTitles:nil];
	[alert show];
}

#pragma mark - Create Reminder Button
- (IBAction)tapReminderButton:(id)sender {
  //NSLog (@" %s %@", __PRETTY_FUNCTION__, [[_eventStore defaultCalendarForNewReminders] title]);
  EKReminder *newReminder = [EKReminder reminderWithEventStore: _eventStore];        //1
  
  newReminder.title = @"Test";                                   //2
  newReminder.notes = _userTextView.text;                         //3
  newReminder.calendar = [_eventStore defaultCalendarForNewReminders];    //4
  NSError *error = nil;
  [_eventStore saveReminder: newReminder commit:YES error: &error];       //5
  //NSLog (@" %s %@ %@ %@", __PRETTY_FUNCTION__, newReminder, newReminder.notes, error );
}



#pragma mark MFMailComposeViewControllerDelegate

- (void)mailComposeController:(MFMailComposeViewController*)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error
{
  [self dismissViewControllerAnimated:YES completion:nil];
}

@end
